# Einfhrungsaufgabe: Kosten fr ein Telegramm berechnen
# Author:: Lars Gerhard

# Diese Dateien werden fr die Unit-Tests bentigt.
require 'runit/testcase'
require 'runit/cui/testrunner'
require 'runit/testsuite'

# == telegramm(msg)
# Diese Methode erkennt mit Hilfe regulrer Ausdrcke Worte, Buchstaben und Stze in einem 
# Eingabestring im Telegrammstil und berechnet entsprechend die Kosten (100 Ct Grundgebhr,
# 20 Ct/Satz, 10 Ct/Wort, 1 Ct/Buchstabe
	def telegramm(msg)
		  worte = 0
			satz = 0
			letter = 0
			msg.scan(/([a-z]|[A-Z])/) {letter = letter+1}
			msg.scan(/([a-z]|[A-Z])+|[0-9]+/) {worte = worte+1}
			msg.scan(/STOP/) {worte = worte-1		
												satz=satz+1
												letter=letter-4}
		print("+------------------------------------------------------------------+\n")	
		print("|                   TELEGRAMMKOSTENBERECHNUNG                      |\n")
		print("+------------------------------------------------------------------+\n")
		print("Tarif: Buchstabe = 1Ct, Wort = 10Ct, Satz = 20Ct, Grundgebuehr=100Ct\n") 
		print("--------------------------------------------------------------------\n")	
		print("Telegrammtext: \n")
		print(msg,"\n")
		print("--------------------------------------------------------------------\n")	
		print("Buchstaben: ",letter,"\n")
		print("Worte     : ",worte, "\n")
		print("Saetze    : ",satz+1,"\n")
		print("--------------------------------------------------------------------\n")
		kosten = 100+20*satz+10*worte+letter
		print("Kosten des Telegramms: ",kosten.to_s," Cent")
		return kosten
	end

# Testklasse
class Testing_class < RUNIT::TestCase

# == test_telegramm
# Es werdem die Kosten fr den Beispieltext "Neuer Rasierer OK STOP Alle Stoppeln weg STOP Gruss 
# und Kuss Peter STOP" berechnet.
	def test_telegramm
	nachricht = "Neuer Rasierer OK STOP Alle Stoppeln weg STOP Gruss und Kuss Peter STOP"
	kosten = 100+3*20+10*10+47
    	assert_equal(kosten, telegramm(nachricht))
  end
end

