# ==zerlege(arittxt)
# Diese Methode zerlegt einen Eingabestring in seine Bestandteile, die durch Ruby-Patterns gegeben sind
# Allerdings werden die einzelnen Teile nicht den Tokenklassen zugeordnet, sondern nur in ein Array ge
# schrieben, welches von der Methode dann zurckgegeben wird. Die Patterns sind:
#
# * bez 				= [a-z][a-z0-9]
# * reg 			  = r[0-9]
# * zahl 				= r2:[0-9]+|[0-9]+
# * op    			= :=|: 

def zerlege(arittxt)
  ergarray=Array.new(0)
  while (arittxt.size > 0) do 
	  tokentemp=""
		c=(arittxt.match('\A([a-z][a-z0-9]*)|(r[0-9])|(r2:[0-9]+|[0-9]+)|(:=|:)'))
		if (c[0]!=nil and arittxt.index(c[0])==0)
			 tokentemp=c[0]
		end
		if(tokentemp=="")
			return Array.new
		end
		ergarray << tokentemp 
		arittxt=arittxt.sub(tokentemp, '')
	end	
	return ergarray
end

def bestimmeToken(text)
	return "op"   if /:=|:/.match(text).to_s == text
	return "zahl" if /r2:[0-9]+|[0-9]+/.match(text).to_s == text 
	return "reg"  if /r[0-9]/.match(text).to_s == text 
	return "bez"  if /[a-z][a-z0-9]*/.match(text).to_s == text 
end

def bestimme(arittxt)
	zerlege(arittxt).each do |part|
	  print(bestimmeToken(part))
		print("<<",part,">>\n")
	end
end

example="r20:=r2:r2:2"
# example="2:2r:2r=:02r"
# example="::=20r:r2:20:=:"

erg = zerlege(example)

if erg.empty?
  print "Irregulaere Eingabe"
  goahead=false
else
  print("+------------------------------------------------+\n")
  print("| Zerlegung ohne Zuordnung zu den Token-Klassen: |\n")
  print("+------------------------------------------------+\n\n")
  erg.each do |comp|
	  print("<<",comp,">>  ")
  end
	print("\n\n")
	print("+-----------------------------------------------+\n")
	print("| Zerlegung mit Zuordnung zu den Token-Klassen: |\n")
	print("+-----------------------------------------------+\n\n")
	print("Akkumulierte Tokens: \n--------------------\n\n")
	bestimme(example)
end