#!/usr/bin/env ruby

require 'fox14'
require 'fox14/colors'
include Fox


# KLasse Monom bildet die math. Beschreibung eines Monoms als Teil eines Polynoms ab
# Autor: Danilo Ebert
class Monom

# Erzeugt ein neues Monom mit dem entspr. Koeffizienten und Exponenten
 def initialize(coeff,exp)
   @coeff=coeff
   @exp=exp
 end

# Berechnet den Wert des Polynoms zu einem gegeben x-Wert
  def eval(x)
    @coeff*x**@exp
  end
  
end

#########################################################################################
#########################################################################################

# KLasse Polynom bildet die math. Beschreibung eines Polynoms ab
# Autor: Danilo Ebert
class Polynom
  
# Erzeugt ein leereys Polynom
	def initialize
    @polynom=Array.new
  end
 
# Erweitert das Polynom am hinteren Ende um ein bergebens Monom 
  def extPoly(monom)
    @polynom << monom
  end
  
# Gibt die Anzahl der Monome zurck
  def length
    @polynom.length
  end
  
# Berechnet den Wert des Polynoms zu einem bergeben x-Wert
  def evalPoly(x)
    @sum = 0.0
		for i in 0..@polynom.length-1 do
      @sum = @sum + (@polynom[i]).eval(x)
    end
    return @sum
		
  end
end



#############################################################################################
#########################################################################################

# Klasse DialogWindow dient zum ffnen eines Dialogfensters zur Eingabe
# eines Polynoms und seiner Parameter
# Autor: Danilo Ebert

class DialogWindow	< FXDialogBox
	
# Erzeugt ein Dialogfenster mit Defaultwerten
	def initialize(owner)
		super(owner,"Auswahlmen", DECOR_ALL, 0, 0,300,500)
		
		menubar  = FXMenuBar.new(self, LAYOUT_SIDE_TOP|LAYOUT_FILL_X)
		filemenu = FXMenuPane.new(self)
	
		FXMenuTitle.new(menubar, "&File", nil, filemenu)
		FXHorizontalSeparator.new(self, SEPARATOR_GROOVE|LAYOUT_FILL_X)

# Erzeugt DataTargets fr die Eingabe des Polynoms und seiner Parameter
    @functionTarget   = FXDataTarget.new("1.0*x**3+1.0*x**2")
		@xCoordTarget     = FXDataTarget.new(290)
		@yCoordTarget     = FXDataTarget.new(325)
		@zoomTarget       = FXDataTarget.new(50)

# Label und Textfeld fr das Polynom
	FXLabel.new(self, "Funktion:", nil,LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_LEFT)
	FXTextField.new(self, 10, @functionTarget,FXDataTarget::ID_VALUE,
									LAYOUT_LEFT|LAYOUT_CENTER_X|FRAME_SUNKEN|FRAME_THICK|
									LAYOUT_LEFT|LAYOUT_FILL_X)

	FXHorizontalSeparator.new(self, SEPARATOR_GROOVE|LAYOUT_FILL_X,20,20,20,20,0,0,10,10)		

# Ein- und Ausschalten der Zoomoption
	FXLabel.new(self, "Zoomfaktor:", nil,LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_LEFT)
  @zoomMode = FXDataTarget.new(false)
  FXCheckButton.new(self, "Zoom", @zoomMode, FXDataTarget::ID_VALUE, CHECKBUTTON_NORMAL|
										LAYOUT_LEFT)

# Slider fr die Zoomeinstellung
	FXSlider.new(self, @zoomTarget, FXDataTarget::ID_VALUE, LAYOUT_TOP|
							 LAYOUT_FIX_WIDTH|LAYOUT_CENTER_X, 0, 0, 100)

# Spinner-Feld fr die Zoomeinstellung
	FXSpinner.new(self, 5, @zoomTarget, FXDataTarget::ID_VALUE,
								SPIN_CYCLIC|FRAME_SUNKEN|FRAME_THICK|LAYOUT_RIGHT)

	FXHorizontalSeparator.new(self, SEPARATOR_GROOVE|LAYOUT_FILL_X,20,20,20,20,0,0,10,10)		

# Label und Textfeld fr den x-Wert des gewnschten Koordinatenursprungs
	FXLabel.new(self, "x-Wert Ursprung:   (0 <= x <= 580)", nil,LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_LEFT)
	FXTextField.new(self, 10, @xCoordTarget,FXDataTarget::ID_VALUE,
									LAYOUT_LEFT|LAYOUT_CENTER_X|FRAME_SUNKEN|FRAME_THICK|LAYOUT_LEFT|
									TEXTFIELD_REAL)

FXHorizontalSeparator.new(self, SEPARATOR_GROOVE|LAYOUT_FILL_X,20,20,20,20,0,0,10,10)		

# Label und Textfeld fr den y-Wert des gewnschten Koordinatenursprungs
	FXLabel.new(self, "y-Wert Ursprung:    (0 <= y <= 650)", nil,LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_LEFT)
	FXTextField.new(self, 10, @yCoordTarget,FXDataTarget::ID_VALUE,
									LAYOUT_LEFT|LAYOUT_CENTER_X|FRAME_SUNKEN|FRAME_THICK|LAYOUT_LEFT|
									TEXTFIELD_REAL)

FXHorizontalSeparator.new(self, SEPARATOR_GROOVE|LAYOUT_FILL_X,20,20,20,20,0,0,10,10)		

#"Draw Function"-Button zum Zeichnen der Funktion		
	drawButton = FXButton.new(self, "&Draw function", nil, nil, 0,LAYOUT_CENTER_X|
														FRAME_THICK|FRAME_RAISED|LAYOUT_TOP|LAYOUT_LEFT,
														0, 0, 0, 0, 20, 20, 5, 5)	
	
	drawButton.connect(SEL_COMMAND) do	
			owner.drawFunction(@functionTarget, @zoomTarget,
												 @zoomMode.value, @xCoordTarget,
												 @yCoordTarget)		
		end
	end
end


#################################################################################################
###############################################################################################

# Klasse ScribbleWindow ist die Hauptanwendung zum Zeichnen
#	von Scribble-Bildern und Polynomfunktionen
# Autor: Carolin Bongartz, Robert Meier, Danilo Ebert
class ScribbleWindow < FXMainWindow

# ffnet einen neue Anwendung des ScribbleFensters
  def initialize(app)
    # Call base class initializer first
    super(app, "Scribble Application", nil, nil, DECOR_ALL,
      0, 0, 700, 700)
		
		@dataString = ""

    # Construct a horizontal frame to hold the main window's contents
    @contents = FXHorizontalFrame.new(self,
      LAYOUT_SIDE_TOP|LAYOUT_FILL_X|LAYOUT_FILL_Y, 0, 0, 0, 0, 0, 0, 0, 0)

    # Left pane contains the canvas
    @canvasFrame = FXVerticalFrame.new(@contents,
      FRAME_SUNKEN|LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,
      0, 0, 0, 0, 10, 10, 10, 10)

    # Place a label above the canvas
    FXLabel.new(@canvasFrame, "Canvas Frame", nil,
      JUSTIFY_CENTER_X|LAYOUT_FILL_X)

    # Horizontal divider line
    FXHorizontalSeparator.new(@canvasFrame, SEPARATOR_GROOVE|LAYOUT_FILL_X)

    # Drawing canvas
    @canvas = FXCanvas.new(@canvasFrame, nil, 0,
      LAYOUT_FILL_X|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT)
    @canvas.connect(SEL_PAINT) do |sender, sel, event|
      FXDCWindow.new(@canvas, event) do |dc|
        dc.foreground = @canvas.backColor
        dc.fillRectangle(event.rect.x, event.rect.y, event.rect.w, event.rect.h)
				
				end
    end

	


    @canvas.connect(SEL_LEFTBUTTONPRESS) do
      @canvas.grab
      @mouseDown = true
    end
    @canvas.connect(SEL_MOTION) do |sender, sel, event|
      if (@mouseDown and @scribbleMode.value)
        # Get device context for the canvas
        dc = FXDCWindow.new(@canvas)
				
        # Set the foreground color for drawing
        dc.foreground = @drawColor.rgba
				
        # Draw a line from the previous mouse coordinates to the current ones
        if @mirrorMode.value
          cW = @canvas.width
          cH = @canvas.height
          dc.drawLine(cW-event.last_x, event.last_y,
                      cW-event.win_x, event.win_y)
          dc.drawLine(event.last_x, cH-event.last_y,
                      event.win_x, cH-event.win_y)
          dc.drawLine(cW-event.last_x, cH-event.last_y,
                      cW-event.win_x, cH-event.win_y)
        end
       		
				dc.drawLine(event.last_x, event.last_y, event.win_x, event.win_y)
 
# Speichert die Koordinaten eines Zeichenvorgangs als String     
				@dataString	= @dataString<<event.last_x.to_s<< 
											"a"<<event.last_y.to_s<< 
											"a"<<event.win_x.to_s << 
											"a"<< event.win_y.to_s<< "b"
				
			
	
				# We have drawn something, so now the canvas is dirty
        @dirty = true

        # Release the DC immediately
        dc.end
      end
    end
    @canvas.connect(SEL_LEFTBUTTONRELEASE) do |sender, sel, event|
      @canvas.ungrab
      if @mouseDown
        # Get device context for the canvas
        dc = FXDCWindow.new(@canvas)

        # Set the foreground color for drawing
        dc.foreground = @drawColor.rgba

        # Draw a line from the previous mouse coordinates to the current ones
        dc.drawLine(event.last_x, event.last_y, event.win_x, event.win_y)

        # We have drawn something, so now the canvas is dirty
        @dirty = true

        # Mouse no longer down
        @mouseDown = false

        # Release this DC immediately
        dc.end
      end
    end


# Zeichnet die das bergebene Polynom mit den bergeben Parametern
			def drawFunction(function,zoomTarget,zoomValue,xCoordTarget,yCoordTarget)
					FXDCWindow.new(@canvas) do |dc|
					dc.foreground = @canvas.backColor
					dc.fillRectangle(0, 0, @canvas.width, @canvas.height)
					@dirty = false
				
# Regulrer Ausdruck zur Zerlegung des Polynoms in Monome
					monomExp = /([\+|-]?\d+\.\d+\*x\*\*\d+)/

					functionArray = function.to_s.scan(monomExp)
					zoom   = zoomTarget.to_s.to_f+0.5
					xCoord = xCoordTarget.to_s.to_f
					yCoord = yCoordTarget.to_s.to_f
					
	if ((xCoord <= @canvas.width)  and (xCoord >= 0) and
			(yCoord <= @canvas.height) and (yCoord >= 0))

# neue Polynominstanz					
					@pol= Polynom.new

# Ermitteln der Koeffizienten und Exponenten
# jedes einzelnen Monoms mit Hilfe von reg. Ausdrcken
					for i in 0..functionArray.length-1 do
						coeff = functionArray[i].to_s.scan(/[\+|-]?\d+.\d+/)[0].to_f
						exp   = functionArray[i].to_s.scan(/\d+/)[2].to_i
						monom=Monom.new(coeff,exp)
						@pol.extPoly(monom)
					end
					
# Nullstelle des Polynoms zur Justierung von Koordinatenursprung und Zoomfaktor
					intersectY = @pol.evalPoly(0)

# Berechnung des ntigen Zoomfaktors
			if !zoomValue	
					const =50
					if intersectY > 0
						while intersectY*const > yCoord
							const = const/2
						end
					else
						if intersectY != 0
							while (intersectY*const).abs > (@canvas.height-yCoord)
								const = const/2
							end
						end
					end	
			else
				const = zoom
			end
			
# Zeichnen und Skalieren der y-Achse				
					dc.foreground = 'black'
					dc.drawLine(xCoord, 0, xCoord, @canvas.height)
					i = yCoord
					j = yCoord
					while ((i.abs+j.abs) <= 2*@canvas.height)
						dc.drawLine(xCoord-5, i+const, xCoord+5, i+const)
						i += const
						dc.drawLine(xCoord-5, j-const, xCoord+5, j-const)
						j -= const
					end
					
# Zeichnen und Skalieren der x-Achse
					dc.drawLine(0, yCoord, @canvas.width, yCoord)
					i = xCoord
					j = xCoord
					while ((i.abs+j.abs) <= 2*@canvas.width)
						dc.drawLine(i+const, yCoord-5, i+const, yCoord+5)
						i += const
						dc.drawLine(j-const, yCoord-5, j-const, yCoord+5)
						j -= const
					end
					
# Berechnen und Zeichnen der Funktion
					dc.foreground = @drawColor.rgba
					i=-12*(50/const)
					while i<12*(50/const)
						dc.drawPoint(xCoord+i*const      , yCoord-@pol.evalPoly(i)*const)
						dc.drawLine(xCoord+(i-0.1)*const , yCoord-@pol.evalPoly(i-0.1)*const,
												xCoord+i*const       , yCoord-@pol.evalPoly(i)*const)
						i=i+0.1
					end
	else
		errorDialog = FXDialogBox.new(self,"Fehler", DECOR_ALL, 0, 0,240,40)
		FXLabel.new(errorDialog, "Fehler: Bitte Prfen Sie den Wertebereich!!!",
								nil,LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_LEFT)
		errorDialog.execute
			end				
 end		


	end

    # Right pane for the buttons
    @buttonFrame = FXVerticalFrame.new(@contents,
      FRAME_SUNKEN|LAYOUT_FILL_Y|LAYOUT_TOP|LAYOUT_LEFT,
      0, 0, 0, 0, 10, 10, 10, 10)

  
		
		# Label above the buttons
    FXLabel.new(@buttonFrame, "Button Frame", nil,
      JUSTIFY_CENTER_X|LAYOUT_FILL_X)

    # Horizontal divider line
    FXHorizontalSeparator.new(@buttonFrame,
      SEPARATOR_RIDGE|LAYOUT_FILL_X)

    # Enable or disable mirror mode
    @mirrorMode = FXDataTarget.new(false)
    FXCheckButton.new(@buttonFrame, "Mirror", @mirrorMode, FXDataTarget::ID_VALUE, CHECKBUTTON_NORMAL|LAYOUT_FILL_X)
	
# Ein- und Ausschalten des manuellen Zoommodus
    @scribbleMode = FXDataTarget.new(false)
    FXCheckButton.new(@buttonFrame, "Scibble", @scribbleMode, FXDataTarget::ID_VALUE, CHECKBUTTON_NORMAL|LAYOUT_FILL_X)

		# Horizontal divider line
    FXHorizontalSeparator.new(@buttonFrame,
    SEPARATOR_RIDGE|LAYOUT_FILL_X)

	
	
    # Button to clear the canvas
    clearButton = FXButton.new(@buttonFrame, "&Clear", nil, nil, 0,
      FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT,
      0, 0, 0, 0, 10, 10, 5, 5)
    clearButton.connect(SEL_COMMAND) do
      FXDCWindow.new(@canvas) do |dc|
        dc.foreground = @canvas.backColor
        dc.fillRectangle(0, 0, @canvas.width, @canvas.height)
        @dirty = false
# Lschen des Speicherstrings
				@dataString = ""
      end
    end
    clearButton.connect(SEL_UPDATE) do |sender, sel, ptr|
      # This procedure handles the update message sent by the Clear button
      # to its target. Every widget in FOX receives a message (SEL_UPDATE)
      # during idle processing, asking it to update itself. For example,
      # buttons could be enabled or disabled as the state of the application
      # changes.
      #
      # In this case, we'll disable the sender (the Clear button) when the
      # canvas has already been cleared (i.e. it's "clean"), and enable it when
      # it has been painted (i.e. it's "dirty").
      message = @dirty ? FXWindow::ID_ENABLE : FXWindow::ID_DISABLE
      sender.handle(self, MKUINT(message, SEL_COMMAND), nil)
		end
		


# Zeichnen eines geladenen Bildes	
	def drawLoadedPicture(str)
			dc = FXDCWindow.new(@canvas)
			dc.foreground = @canvas.backColor
			dc.fillRectangle(0, 0, @canvas.width, @canvas.height)
			dc.foreground = @drawColor.rgba
			
			stringArray = str.scan(/-?\d+/)

# Auslesen der 4 Koordinaten mit Hilfe von reg. Ausdrcken			
			while stringArray.length != 0
				dc.drawLine(stringArray[0].to_i, stringArray[1].to_i, stringArray[2].to_i, stringArray[3].to_i)
				stringArray.delete_at(0)
				stringArray.delete_at(0)
				stringArray.delete_at(0)
				stringArray.delete_at(0)
			end
			@dirty = true
	end
	
#Save-Button zum Speichern eines gezeichneten Bildes	
			saveButton = FXButton.new(@buttonFrame, "&Save", nil, nil, 0,
																FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT,
																0, 0, 0, 0, 10, 10, 5, 5)
			
			saveButton.connect(SEL_COMMAND)do
						File.open("Bild","w") do |f|
						Marshal.dump(@dataString,f)
						end
			end

#Load-Button zum Laden eines gespeicherten Bildes	
			loadButton = FXButton.new(@buttonFrame, "&Load", nil, nil, 0,
																FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT,
																0, 0, 0, 0, 10, 10, 5, 5)
		
			loadButton.connect(SEL_COMMAND)do
						File.open("Bild") do |f|
						str=(Marshal.load(f))
						drawLoadedPicture(str)
						end
			end



# DialogBoxButton	zum Erzeugen des Dialogfensters
			dialButton = FXButton.new(@buttonFrame, "&DialogBox", nil, nil, 0,
																FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT,
																0, 0, 0, 0, 10, 10, 5, 5)	

			dialButton.connect(SEL_COMMAND)do
						if !@scribbleMode.value
								dialog=DialogWindow.new(self)
								dialog.execute
			end

			dialButton.connect(SEL_UPDATE) do |sender, sel, ptr|
								message = !@scribbleMode.value ? FXWindow::ID_ENABLE : FXWindow::ID_DISABLE
								sender.handle(self, MKUINT(message, SEL_COMMAND), nil)
			end

end

	

		# Exit button
			FXButton.new(@buttonFrame, "&Exit", nil, app, FXApp::ID_QUIT,
									 FRAME_THICK|FRAME_RAISED|LAYOUT_FILL_X|LAYOUT_TOP|LAYOUT_LEFT,
									 0, 0, 0, 0, 10, 10, 5, 5)
									 

# Label und ColorWell zur Festlegung der Zeichenfarbe
    FXLabel.new(@buttonFrame, "&Color", nil,
								LAYOUT_LEFT|LAYOUT_TOP|LAYOUT_LEFT)
    
	
	
	@drawColor = FXColorWell.new(@buttonFrame, FXColor::Black, nil, FXDataTarget::ID_VALUE,
																 LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK|LAYOUT_LEFT)
    @drawColor.connect(SEL_COMMAND, method(:onCmdWell))


    # Initialize other member variables
    @mouseDown = false
    @dirty = false
  end

  # Create and show the main window
  def create
    super                  # Create the windows
    show(PLACEMENT_SCREEN) # Make the main window appear
  end


# ColorWell wird verndert
		def onCmdWell(sender, sel, ptr)
			@canvas.update
		end
end




if __FILE__ == $0
  # Construct the application object
  application = FXApp.new('Scribble', 'FoxTest')
  
  # Construct the main window
  scribble = ScribbleWindow.new(application)
  
  # Create the application
  application.create
  
  # Run the application
  application.run
end
